"""
	Smart Multifaceted Platform ™
	© 2019 - 2022 - Bouygues Energies & Services

	Bibliothèque de gestion utils
"""

import system
import shared.commun.constantes
import shared.commun.logger

strLib = "perspective.gui.utils"

def getGatewayIpAddress(session):
	try:
		global strLib
		strFct="getGatewayIpAddress"
		address = session.props.gateway.address		
		# Example : "http://10.100.3.30:9088" => 10.100.3.30		
		return address.split("//")[1].split(":")[0]
	except:
		shared.commun.logger.logERROR(strFct=strFct,strLib=strLib)
		return ""

def getClientIpAddress(session):
	"""
		retourne liste de 1 ou 2 adresses (127.0.0.1 si localhost)        
	"""
	global strLib
	strFct="getClientIpAddress"
	result = []
	try:
		ipAddress = session.props.address
		if ipAddress.count(".")<3 or ipAddress == "localhost":
			ipAddress = "127.0.0.1"
		result.append(ipAddress)

		gwAddress = session.props.gateway.address
		if ("localhost" in gwAddress) or ("127.0.0.1" in gwAddress):
			if "127.0.0.1" not in result:
				result.append("127.0.0.1")
	except:
		shared.commun.logger.logERROR(strFct=strFct,strLib=strLib)
	return result
