"""
	Smart Multifaceted Platform ™
	© 2019 - 2022 - Bouygues Energies & Services
	
	Bibliothèque Client Event Scripts - message
"""

import system
import shared.commun.logger
import shared.commun.constantes

strLib = "project.clientevents.message"

def IHM_AffecterIncrustationVideoMultiple(payload):
	try:
		import project.gui.video
		import shared.commun.constantesCustom
		global strLib		
		strFct = "IHM_AffecterIncrustationVideoMultiple"
		strMsg = u"payload=%s" % payload
		shared.commun.logger.logDEBUG(strMsg=strMsg,strFct=strFct,strLib=strLib)
		
		ipAddress = payload["ipAddress"]		
		position = payload["position"] 
		tagCamera = payload["tagCamera"]		
		
		try:
			ipFilter = shared.commun.constantesCustom.IP_CLIENT_FILTER_VIDEO_WALL
		except:
			ipFilter = True
		
		ipClient = getClientIpAddress()
		
		if any(elem in ipClient for elem in ipAddress) or (ipFilter == False):
			project.gui.video.affecterIncrustationVideoMultiple(position,tagCamera,payload=payload)		
	except:
		shared.commun.logger.logERROR(strFct=strFct,strLib=strLib)

def getClientIpAddress():
	"""
		retourne liste de 1 ou 2 adresses (127.0.0.1 si localhost)        
	"""
	global strLib
	strFct="getClientIpAddress"
	result = []
	try:
		ipAddress = system.tag.readBlocking("[System]Client/Network/IPAddress")[0].value
		if ipAddress == "localhost":
			ipAddress = "127.0.0.1"
		result.append(ipAddress)

		gwAddress = system.tag.readBlocking("[System]Client/Network/GatewayAddress")[0].value
		if ("localhost" in gwAddress) or ("127.0.0.1" in gwAddress):
			if "127.0.0.1" not in result:
				result.append("127.0.0.1")
	except:
		shared.commun.logger.logERROR(strFct=strFct,strLib=strLib)
	return result