"""
	Smart Multifaceted Platform ™
	© 2019 - 2022 - Bouygues Energies & Services

	Bibliothèque de gestion du popup video
"""

import system
import shared.commun.logger
import shared.commun.constantes
import shared.commun.video

import project.gui.constantes

strLib = "project.gui.video"

def rechercherCamera(tagCamera):
	"""
		Fonction recherche données caméra
		Args: tagCamera de la forme 'CDM-EXT-CAF-01'
		Returns dicoCamera 
	"""	
	import shared.commun.video
	
	global strLib
	strFct="rechercherCamera"	
	
	global tagPathsCamera	
	dicoCamera = {}
	try:
		dicoCamera = shared.commun.video.rechercherCamera(tagCamera)
	except:
		shared.commun.logger.logERROR(strMsg='Erreur runNamedQuery',strFct=strFct,strLib=strLib)
	return dicoCamera

# nota eqtPath pas tjs fourni, exemple : dropdown liste de caméra
def affecterIncrustationVideo(tagCamera,eqtPath,desktop=""):

	global strLib
	strFct="affecterIncrustationVideo"		

	# /!\ invokeAsynchronous tjs dans le contexte du primary
	# recupérer les desktop avant
	
	if desktop=="":
		desktop = system.gui.getCurrentDesktop()
		
	def affecterIncrustationVideo_internal(tagCamera=tagCamera,eqtPath=eqtPath,desktop=desktop):
		"""
			Fonction affectation incrustation Video
			Args: tagCamera de la forme 'CDM-EXT-CAF-01'
		"""
		import system
		global strLib
		strFct="affecterIncrustationVideo"
		
		global tagPathsCamera
		
		try:
			strFct="affecterIncrustationVideo_internal"		
			shared.commun.logger.logDEBUG(strFct=strFct,strLib=strLib,strMsg="desktop=%s,tagCamera=%s,eqtPath=%s"%(desktop,tagCamera,eqtPath))
		
			# recherche des données de configuration de la caméra
			dicoCamera = rechercherCamera(tagCamera)
			
			if (dicoCamera != None and len(dicoCamera)>0):
				tagPaths = []
				values = []
				
				# /!\ une  seule caméra pour les 2 écrans
				# Forcer les mêmes paramètres dans les tags de chaque desktop				
				handleList = system.gui.getDesktopHandles()
				handleList.append("primary")
				
				if shared.commun.constantes.getConstantePLATFORM("joystick_on"):
					import project.gui.joystick
					for handleDesktop in handleList:
						endpointAddress = system.tag.readBlocking([tagPathsCamera["endpointAddress"] % handleDesktop])[0].value						
						profileToken = system.tag.readBlocking([tagPathsCamera["ptzProfileToken"] % handleDesktop])[0].value
					project.gui.joystick.freeController(endpointAddress,profileToken,source="incrust")
				
				for handleDesktop in handleList:	
					
					tagPaths.append(tagPathsCamera["tagCamera"] % handleDesktop)
					tagPaths.append(tagPathsCamera["endpointAddress"] % handleDesktop)
					tagPaths.append(tagPathsCamera["endpointUser"] % handleDesktop)
					tagPaths.append(tagPathsCamera["endpointPassword"] % handleDesktop)			
					tagPaths.append(tagPathsCamera["ptzActivePanTilt"] % handleDesktop)
					tagPaths.append(tagPathsCamera["ptzActiveZoom"] % handleDesktop)
					tagPaths.append(tagPathsCamera["ptzProfileToken"] % handleDesktop)
					tagPaths.append(tagPathsCamera["streamUser"] % handleDesktop)
					tagPaths.append(tagPathsCamera["streamPassword"] % handleDesktop)
					tagPaths.append(tagPathsCamera["streamUrl"] % handleDesktop)					
					tagPaths.append(tagPathsCamera["eqtPath"] % handleDesktop)
					tagPaths.append(tagPathsCamera["idCam"] % handleDesktop)				
					
					values.append(tagCamera)
					values.append(dicoCamera["endpointAddress"])
					values.append(dicoCamera["endpointUser"])
					values.append(dicoCamera["endpointPassword"])
					values.append(dicoCamera["ptzActivePanTilt"])
					values.append(dicoCamera["ptzActiveZoom"])
					values.append(dicoCamera["ptzProfileToken"])
					values.append(dicoCamera["streamUser"])
					values.append(dicoCamera["streamPassword"])
					values.append(dicoCamera["streamUrl"])					
					values.append(eqtPath)
					values.append(dicoCamera["idCam"])				
					
				# paramètres à positionner avant affectation
				system.tag.writeAllSynchronous(tagPaths,values,2)
				declencherMajVideo(desktop=desktop)	
		except:
			shared.commun.logger.logERROR(strFct=strFct,strLib=strLib)
			
	system.util.invokeAsynchronous(affecterIncrustationVideo_internal)

def declencherMajVideo(desktop):
	global strLib
	strFct="declencherMajVideo"
	
	global tagPathsCamera
	
	try:
		shared.commun.logger.logDEBUG(strFct=strFct,strLib=strLib,strMsg="desktop=%s"%desktop)
		pathCommande = tagPathsCamera["affecterCamera"] % desktop			
		# le tag de commande est traité dans le popup incrustation si valeur = True
		# et RAZ
		# Cas ou le tag est resté à True
		if system.tag.read(pathCommande).value == True:				
			system.tag.write(pathCommande, False)
			#print "WRITE affecterCamera FALSE"
			def later():
				import system
				system.tag.write(pathCommande, True)
				#print "WRITE affecterCamera TRUE"
			system.util.invokeLater(later,1000)
		else:
			system.tag.write(pathCommande, True)
			#print "WRITE affecterCamera TRUE"
	except:
	   shared.commun.logger.logERROR(strFct=strFct,strLib=strLib)

def affecterIncrustationVideoMultiple(position,tagCamera,desktop="",payload=None):
	"""
		payload est fourni si affectation depuis project.clientevents.message.IHM_AffecterIncrustationVideoMultiple(payload)
		ce qui correspond à un appel depuis le client perspective
	"""
	import system.byes.utilsvideo.message
	global strLib
	strFct="affecterIncrustationVideoMultiple"		
	
	try:			
		shared.commun.logger.logDEBUG(strFct=strFct,strLib=strLib,strMsg="position=%s,tagCamera=%s"%(position,tagCamera))
	
		if payload != None:
			system.byes.utilsvideo.message.send("affecter_camera",payload)
		else:	
			# recherche des données de configuration de la caméra
			dicoCamera = rechercherCamera(tagCamera)
			
			if (dicoCamera != None and len(dicoCamera)>0):
				
				# envoie message pour vue du mur d'image local
				payload={}
				payload["position"] = position
				#payload["eqtPath"] = eqtPath
				payload["tagCamera"] = tagCamera
				
				payload["endpointAddress"] = dicoCamera["endpointAddress"]
				payload["endpointUser"] = dicoCamera["endpointUser"]
				payload["endpointPassword"] = dicoCamera["endpointPassword"]			
				payload["ptzActivePanTilt"] = dicoCamera["ptzActivePanTilt"]
				payload["ptzActiveZoom"] = dicoCamera["ptzActiveZoom"]
				payload["ptzProfileToken"] = dicoCamera["ptzProfileToken"]
				payload["streamUser"] = dicoCamera["streamUser"]
				payload["streamPassword"] = dicoCamera["streamPassword"]
				payload["streamUrl"] = dicoCamera["streamUrl"]
				#payload["idCam"] = dicoCamera["idCam"]
				payload["eqtPath"] = dicoCamera["eqtPath"]
				
				system.byes.utilsvideo.message.send("affecter_camera",payload)				
	except:
		shared.commun.logger.logERROR(strFct=strFct,strLib=strLib)

def localiserEqtClientPerspective(eqtPath):
	"""
		Fonction appelé depuis la vue d'incrustation vidéo multiple pour localiser l'équipement caméra
		dans le client Perspective
	"""
	global strLib
	strFct="localiserEqtClientPerspective"	
	try:
		shared.commun.logger.logINFO(strFct=strFct,strLib=strLib,strMsg="eqtPath=%s" % eqtPath)
		
		# envoie message pour vue du mur d'image local
		payload={}
		payload["eqtPath"] = eqtPath
			
		# Message pour le client perspective qui tourne sur le même PC
		project = shared.commun.constantesCustom.PEER_PROJECT_VIDEO_WALL

		messageHandler = "IHM_LocaliserEqt"
		scope = "S"
		#hostName = session.props.host
		
		def getClientIpAddress():
			"""
				retourne liste de 1 ou 2 adresses (127.0.0.1 si localhost)        
			"""
			global strLib
			strFct="getClientIpAddress"
			result = []
			try:
				ipAddress = system.tag.readBlocking("[System]Client/Network/IPAddress")[0].value
				if ipAddress == "localhost":
					ipAddress = "127.0.0.1"
				result.append(ipAddress)
		
				gwAddress = system.tag.readBlocking("[System]Client/Network/GatewayAddress")[0].value
				if ("localhost" in gwAddress) or ("127.0.0.1" in gwAddress):
					if "127.0.0.1" not in result:
						result.append("127.0.0.1")
			except:
				shared.commun.logger.logERROR(strFct=strFct,strLib=strLib)
			return result
		
		# provoque une erreur !
		#payload["ipAddress"] = project.gui.utils.getClientIpAddress()
		payload["ipAddress"] = getClientIpAddress()
		
		strMsg="sendMessage : project=%s, messageHandler=%s, scope=%s, payload=%s" % (project,messageHandler,scope,payload)
		shared.commun.logger.logDEBUG(strFct=strFct,strLib=strLib,strMsg=strMsg)
		
		# session.props.host pour filtrage hostName contient une @IP au lieu d'un host
		# sendMessage avec filtre hostName ne fonctionne pas			 
		#,hostName=hostName)
		# Gestion filtre manuel avec [System]Client/Network/IPAddress
		# et cas particulier localhsot/127.0.0.1
		
		system.util.sendMessage(project=project,messageHandler=messageHandler,payload=payload,scope=scope)				
	except:
		shared.commun.logger.logERROR(strFct=strFct,strLib=strLib)
