"""
	Smart Multifaceted Platform ™
	© 2019 - 2022 - Bouygues Energies & Services

	Bibliothèque de gestion de la navigation des vues
"""

import system
import shared.commun.logger

strLib = "project.nav.windows"

def exit(desktop=""):
	global strLib
	strFct="exit"		
	try:
		msg = u"Quitter l'application ?"
		if project.gui.popup.confirm(msg,allowCancel=False):
			system.util.exit()
	except:
		shared.commun.logger.logERROR(strFct=strFct,strLib=strLib)

indexPrimary = 0

def swapScreens():
	global strLib
	strFct="swapScreens"	

	global indexPrimary

	try:
		desktop = system.gui.getCurrentDesktop()
		# liste des desktop en plus du main
		handleList = system.gui.getDesktopHandles()	
		screens = system.gui.getScreens()
		
		if (len(screens)>=2):		
			if indexPrimary==0:
				indexPrimary=1
				indexSecondary=0
			else:
				indexPrimary=0
				indexSecondary=1
			# si un seul desktop => le change de moniteur
			if len(handleList)==0:
				system.gui.desktop("primary").setScreenIndex(indexPrimary)
			# si 2 desktop => inversion des 2 desktops
			# si +, non traité
			elif len(handleList)==1:
				system.gui.desktop("primary").setScreenIndex(indexPrimary)
				system.gui.desktop("secondary").setScreenIndex(indexSecondary)
	except:
		shared.commun.logger.logERROR(strFct=strFct,strLib=strLib)

def openDiagnostics():
	global strLib
	strFct="openDiagnostics"	
	try:	
		desktop = system.gui.getCurrentDesktop()
		system.gui.desktop(desktop).openDiagnostics()
	except:
		shared.commun.logger.logERROR(strFct=strFct,strLib=strLib)
