"""
	Smart Multifaceted Platform ™
	© 2019 - 2023 - Bouygues Energies & Services

	Bibliothèque de constantes custom à surcharger dans le projet cible
"""

import system

#--------------------------------------------------------------------------------------------------------------
# mandatory
#--------------------------------------------------------------------------------------------------------------

ROOT_LOGGER = "STARTER_KIT_VIDEO_LOG"

PLATFORM = {
	"perspective_on" : True,
	"vision_on" : True,
	"video_on" : True, 						# Need module : BYES-VideoViewerNextGen
	"joystick_on" : False, 					# Need module : BYES-JoystickDriver
}

# PLATFORM.video_on
# dans le projet vision SMP_VIDEO_WALL => indiquer le project perspective SMP_DEMO
# dans le projet perspective SMP_DEMO => indiquer le projet vision SMP_VIDEO_WALL
#PEER_PROJECT_VIDEO_WALL = "STARTER_KIT_VIDEO"
PEER_PROJECT_VIDEO_WALL = system.project.getProjectName()
# pour que les clients vidéo recoivent toutes les affectations et non pas seulement celles du même poste client
# plus pratique pour demo mode en localhost
IP_CLIENT_FILTER_VIDEO_WALL = False

# PLATFORM.video_on
VIDEO_SERVER = {	
	"maxPerspectiveClient" : 5,
	"rtpMinPort" : 30000,
	"rtpMaxPort" : 30004,	
	# utilisé pour gestion re-encodage des flux non h264, type h265 en vp8 ou autre
	# dans perspective.gui.video.getQualityStreamProcess(output_stream_process)
	"outputStreamProcessQuality" : {
		# vp8
		#"deadline=1"
		#"deadline=1 target-bitrate=1000000 threads=1"
		#"deadline=1 target-bitrate=2000000 threads=2"
		#"deadline=1 target-bitrate=2000000 threads=4"
		#"deadline=1 target-bitrate=4000000 threads=4"
		#"deadline=1 target-bitrate=8000000 threads=4"		
		"vp8" : "deadline=1",
		# A revoir si usage
		"vp9" : "deadline=1",
		"h264_enc" : "",
		"nvh264enc" : "preset=5"
	},
	"rtph264payOption" : {
		"nvh264enc" : "config-interval=1"
	},
	# camera de démo utilisée pour toute les demandes si demoMode = True
	# voir shared.commun.video.rechercherCamera
	"demoMode" : True,
	"demoCamera" : {	
		"TAPO" : {
			# ONVIF
			"endpointAddress" : "http://192.168.68.124:2020/onvif/ptz_service", # onvif/service
			"endpointPassword" : u"admintapo",
			"endpointUser" : "admintapo",
			# RSTP
			"streamUrl" : "rtsp://192.168.68.124:554/stream1",
			"streamPassword" : u"admintapo",
			"streamUser" : "admintapo",
			# ONVIF PTZ
			"ptzActivePanTilt" : True,
			"ptzActiveZoom" : True,
			"ptzProfileToken" : "profile_1",
			# réf caméra		
			"idCam" : 1,
			"eqtPath" : "path/to/cam1"
		},
		"IMOU":  {
			# ONVIF
			"endpointAddress" : "http://192.168.2.200/onvif/ptz_service",
			"endpointPassword" : u"Lenl031075*",
			"endpointUser" : "admin",
			# RSTP
			#"streamUrl" : "rtsp://192.168.2.200:554/cam/realmonitor?channel=1&subtype=0&unicast=true&proto=Onvif",
			"streamUrl" : "rtsp://192.168.2.200:554/cam/realmonitor?channel=1&subtype=0",
			"streamPassword" : u"Lenl031075*",
			"streamUser" : "admin",
			# ONVIF PTZ
			"ptzActivePanTilt" : True,
			"ptzActiveZoom" : False,
			"ptzProfileToken" : "Profile000",
			# réf caméra		
			"idCam" : 2,
			"eqtPath" : "path/to/cam2",
			# re-encodage si source h265
			#"output_stream_process" : "vp8"
			#"output_stream_process" : "h264"
			#"pipeline" : ""
		},
		"CAM_H265_NATIF" : {		
			# ONVIF
# NB : sera utilisé ici que par le client local
# config à mettre sur la gateway IHM
			"endpointAddress" : "http://192.168.68.124:2020/onvif/ptz_service", # onvif/service
			"endpointPassword" : u"admintapo",
			"endpointUser" : "admintapo",
			# RSTP
			#"streamUrl" : "rtsp://10.60.1.2:554",
			"streamUrl" : "rtsp://service:BYESsiai73!BREST@10.60.1.2:554",	
			#"streamPassword" : u"service",
			#"streamUser" : "BYESsiai73!BREST",
			"streamPassword" : u"",
			"streamUser" : "",
			# ONVIF PTZ
			"ptzActivePanTilt" : True,
			"ptzActiveZoom" : True,
			"ptzProfileToken" : "profile_1",
			# réf caméra		
			"idCam" : 1,
			"eqtPath" : "path/to/cam1",
# encodage x264enc,openh264enc,nvh264enc,nvautogpuh264enc,nvcudah264enc	
			#"output_stream_process" : "vp8"
			#"output_stream_process" : "openh264enc",
#			"output_stream_process" : "nvh264enc",
# 			"pipeline" : """
# 				rtspsrc location=rtsp://10.60.1.2 protocols=tcp user-id=service user-pw=BYESsiai73!BREST latency=0 ! decodebin ! videoconvert ! queue ! nvh264enc preset=5
 #				! queue ! rtph264pay config-interval=1 ! queue ! application/x-rtp,media=video,encoding-name=H264,payload=96 ! webrtcbin.
 #				webrtcbin name=webrtcbin bundle-policy=max-bundle
 #				"""
 			"output_stream_process" : "h265"
		}		
	}	
}




